#! /bin/sh

# ircd-ratbox	Start/stop the ratbox IRC server.

# This file is based on debian's ircd-hybrid init script
# Version:	ircd-hybrid  7.0rc9-1  03-Mar-2003  joshk@triplehelix.org
# Version:	ircd-hybrid  7.2.2-2   10-Sep-2006  ag@roxor.cx
# Version:	ircd-ratbox  2.2.6-1   21-Aug-2007  acornet@debian.org

### BEGIN INIT INFO
# Provides:          ircd-ratbox
# Required-Start:    $remote_fs $network
# Required-Stop:     $remote_fs $network
# Should-Start:      $named $time
# Should-Stop:       $named $time
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: ircd-ratbox daemon init.d script
# Description:       Control ircd-ratbox IRC server daemon.
### END INIT INFO

PATH=/sbin:/bin:/usr/sbin:/usr/bin
DESC="ratbox IRC Server"
NAME=ircd-ratbox
VARRUN=/var/run/ircd
PIDFILE=$VARRUN/$NAME.pid
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="-pidfile /var/run/ircd/$NAME.pid"
DAEMON_USER=irc
DAEMON_GROUP=irc
ENABLED=0

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

test "$ENABLED" != "0" || exit 0

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions


do_start()
{
	if [ ! -d $VARRUN ] ; then
		# /var/run can be cleaned at reboot
		mkdir $VARRUN
		chown $DAEMON_USER:$DAEMON_GROUP $VARRUN
	fi
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --chuid $DAEMON_USER:$DAEMON_GROUP \
		--pidfile "$PIDFILE" --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --chuid $DAEMON_USER:$DAEMON_GROUP \
		--pidfile "$PIDFILE" --exec $DAEMON -- $DAEMON_ARGS > /dev/null \
		|| return 2
	return 0
}

do_stop()
{
	start-stop-daemon --stop --quiet --user $DAEMON_USER \
		--pidfile "$PIDFILE" --retry=TERM/30/KILL/5
	RETVAL="$?"

	# cleanup in case it dies
	rm -f $PIDFILE

	return "$RETVAL"
}

do_reload()
{
	start-stop-daemon --stop --quiet --user $DAEMON_USER \
		--pidfile "$PIDFILE" --signal 1
}

case "$1" in
start)
	log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
	0) log_end_msg 0 ; exit 0 ;;
	1) log_warning_msg " (already running)." ; exit 0 ;;
	2) log_end_msg 1 ; exit 1 ;;
	esac
	;;
stop)
	log_daemon_msg "Stopping $NAME" "$NAME"
	do_stop
	case "$?" in
	0) log_end_msg 0 ; exit 0 ;;
	1) log_warning_msg " (not running)." ; exit 0 ;;
	2) log_end_msg 1 ; exit 1 ;;
	esac
	;;
reload)
	log_daemon_msg "Reloading $NAME" "$NAME"
	do_reload
	log_end_msg $?
	;;
restart|force-reload)
	log_daemon_msg "Restarting $NAME" "$NAME"
	do_stop
	case "$?" in
	0|1)
		do_start
		case "$?" in
		0) log_end_msg 0 ; exit 0 ;;
		1) log_failure_msg " (failed -- old process is still running)." ; exit 1 ;;
		2) log_failure_msg " (failed to start)." ; exit 1 ;;
		esac
		;;
	2)
		log_failure_msg " (failed to stop)." && exit 1
		;;
	esac
	;;
status)
	# PID file is perm'd 600, so only use -p if readable
	if [ -r "$PIDFILE" ]; then
		status_of_proc -p "$PIDFILE" "$DAEMON" "$NAME" && exit 0 || exit $?
	else
		status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
	fi
	;;
conftest)
	start-stop-daemon --start --quiet --chuid $DAEMON_USER:$DAEMON_GROUP --exec $DAEMON -- -conftest
	;;
*)
	echo "Usage: /etc/init.d/$NAME {start|stop|restart|reload|force-reload|status}" >&2
	exit 3
	;;
esac

exit 0
